Loading...
Searching...
No Matches
Common Definitions
Foundation Classes

## Namespaces

namespace | BALL::Constants
namespace | BALL::Exception
namespace | BALL::RTTI

## Classes

class | BALL::Exception::GeneralException
class | BALL::VersionInfo

## Macros

#define | BALL_CREATE_DEEP(name)

## Functions

BALL_EXPORT std::ostream & | BALL::operator<< (std::ostream &os, const Exception::GeneralException &e)
BALL_EXPORT string | BALL::streamClassName (const std::type_info &t)

## Detailed Description

This chapter contains all relevant information on very fundamental definitions and classes used throughout BALL (part of the Foundation Classes).

## Macro Definition Documentation

## BALL_CREATE_DEEP

#define BALL_CREATE_DEEP | ( |  | name | ) |

Value:
\
virtual void* create(bool deep = true, bool empty = false) const\
{\
void* ptr;\
if (empty == true)\
{\
ptr = (void*)new name;\
}\
else\
{\
ptr = (void*)new name(*this, deep);\
}\
\
return ptr;\
}\
\
static void* createDefault()\
{\
return static_cast<void*>(new name);\
}

Virtual construction macro. This macro is used to define the virtual create method. On inclusion of this macro in the public interface of a class, the virtual creation method becomes available. The create method's signature is as follows: virtual void* create(bool deep = true, bool empty = false) const

  The create method either creates an empty default object of the class (empty == true) or a copy of the object. The copy is either deep (deep == true) or shallow (deep == false). By default, the create methods returns a pointer to a deep copy of the object. The use of the create method requires a (public) default constructor (when creating an empty copy) or a copy constructor.

  The macro also implements a static method createDefault that returns a void pointer to a new instance of name.

Parameters

  name | the class name

Definition at line 26 of file create.h.

## Function Documentation

## operator<<()

BALL_EXPORT std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const Exception::GeneralException & | e )

Output operator for exceptions. All BALL exceptions can be printed to an arbitrary output stream. Information written contains the exception class, the error message, and the location (file, line number). The following code block can thus be used to catch any BALL exceptions and convert them to human readable information:

    try
    {
      .... // some code which potentially throws an exception
    }
    catch (Exception::GeneralException& e)
    {
      Log.error() << "caught exception: " << e << std::endl;
    }

## streamClassName()

BALL_EXPORT string BALL::streamClassName | ( | const std::type_info & | t | ) |

Returns a unique name for a class. This name contains no blanks. It is usually derived by substituting all blanks in the name (as returned by RTTI::getName()) with underscores ("_"). In the case of gcc, however a name demangling decodes the string first. This function is needed for object persistence.

Parameters

  t | the type_info structure as returned by typeid

Returns
  string the coverted class name